=begin
#Samplify API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.0

=end

require 'uri'

module SamplifyAPIClient
  class AttributesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # list attributes
    # @param country_iso_code Country ISO code
    # @param language_iso_code Language ISO code
    # @param [Hash] opts the optional parameters
    # @option opts [String] :id Only return attributes with the given id
    # @option opts [Integer] :limit Maximum number of attributes to return (default to 10)
    # @option opts [String] :name Only return attributes with the given name
    # @option opts [Integer] :offset The first zero-based offset attribute to return (default to 0)
    # @option opts [Array<String>] :sort Sort the attributes by the given key(s)
    # @option opts [String] :text Only return attributes with the given text
    # @return [Attributes]
    def attributes_list(country_iso_code, language_iso_code, opts = {})
      data, _status_code, _headers = attributes_list_with_http_info(country_iso_code, language_iso_code, opts)
      data
    end

    # list attributes
    # @param country_iso_code Country ISO code
    # @param language_iso_code Language ISO code
    # @param [Hash] opts the optional parameters
    # @option opts [String] :id Only return attributes with the given id
    # @option opts [Integer] :limit Maximum number of attributes to return
    # @option opts [String] :name Only return attributes with the given name
    # @option opts [Integer] :offset The first zero-based offset attribute to return
    # @option opts [Array<String>] :sort Sort the attributes by the given key(s)
    # @option opts [String] :text Only return attributes with the given text
    # @return [Array<(Attributes, Fixnum, Hash)>] Attributes data, response status code and response headers
    def attributes_list_with_http_info(country_iso_code, language_iso_code, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AttributesApi.attributes_list ...'
      end
      # verify the required parameter 'country_iso_code' is set
      if @api_client.config.client_side_validation && country_iso_code.nil?
        fail ArgumentError, "Missing the required parameter 'country_iso_code' when calling AttributesApi.attributes_list"
      end
      # verify the required parameter 'language_iso_code' is set
      if @api_client.config.client_side_validation && language_iso_code.nil?
        fail ArgumentError, "Missing the required parameter 'language_iso_code' when calling AttributesApi.attributes_list"
      end
      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling AttributesApi.attributes_list, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] < 1
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling AttributesApi.attributes_list, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'offset'].nil? && opts[:'offset'] < 0
        fail ArgumentError, 'invalid value for "opts[:"offset"]" when calling AttributesApi.attributes_list, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = '/sample/v1/attributes/{countryIsoCode}/{languageIsoCode}'.sub('{' + 'countryIsoCode' + '}', country_iso_code.to_s).sub('{' + 'languageIsoCode' + '}', language_iso_code.to_s)

      # query parameters
      query_params = {}
      query_params[:'id'] = opts[:'id'] if !opts[:'id'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'sort'] = @api_client.build_collection_param(opts[:'sort'], :multi) if !opts[:'sort'].nil?
      query_params[:'text'] = opts[:'text'] if !opts[:'text'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/vnd.attributes+json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/xml', 'application/gob', 'application/x-gob'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['jwt']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Attributes')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AttributesApi#attributes_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
